package jp.kambayashi.gl05;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;

import javax.microedition.khronos.egl.EGL10;
import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.egl.EGLContext;
import javax.microedition.khronos.egl.EGLDisplay;
import javax.microedition.khronos.egl.EGLSurface;
import javax.microedition.khronos.opengles.GL10;

import android.opengl.GLU;
import android.util.Log;

public class GLThread extends Thread {
	//IuWFNgʎq
	private String mName;
	//ʊǗIuWFNg
	private GLView mView;
	//stO
	private boolean mDone;
	//`wp[
	private Renderer mRenderer;
	//]px
	private float mAngle;

	//ES_OReLXg
	private EGLContext mEglContext;
	//ESfBXvCRlNV
	private EGLDisplay mEglDisplay;
	//EST[tFCX
	private EGLSurface mEglSurface;
	//ESRtBO
	private EGLConfig mEglConfig;
	
	/**
	 * RXgN^
	 * @param view	
	 */
	public GLThread(GLView view){
		mView = view;
		mName = "GLThread";
		mDone = false;
		mRenderer = new Renderer();
		mAngle = 0;
	}

	/**
	 * XbhX^[g
	 */
	@Override
	public void run() {
		//OpenGL ES̏
		if( !initGLES() ){
			Log.e(mName, "OpenGL ESs");
			mDone = true;
		}
			
		//Ivł܂ŌJԂ
		GL10 gl = (GL10)mEglContext.getGL();
		while(!mDone){
			//`
			drawFrame(gl);
		}
		
		//OpenGL ES̕Еt
		endGLES();
	}
	
	/**
	 * `
	 * 
	 * @param gl	OpenGLnh
	 */
	private void drawFrame( GL10 gl ){
		//r[|[gݒ
		gl.glViewport(0,0,mView.getWidth(),mView.getHeight());
        
		{
        	//ˉesݒ
        	gl.glMatrixMode(GL10.GL_PROJECTION);
        	gl.glLoadIdentity();
        	
			//E(pAʂ̃AXyNgAߎ_A_)̐ݒ
        	float aspect = (float)mView.getWidth() / (float)mView.getHeight();
        	GLU.gluPerspective(gl, 45.0f, aspect, 0.1f, 10.0f);
        }
		
        {
        	//fr[s̐ݒ
        	gl.glMatrixMode(GL10.GL_MODELVIEW);
        	//Pʍs
        	gl.glLoadIdentity();
        	//J̐ݒ
        	float 
        		eyeX = (float)Math.sin(mAngle) * 3.0f,	//J̈ʒuX,ZςBY͍Ȃ̂ň
        		eyeZ = (float)Math.cos(mAngle) * 3.0f;
        	GLU.gluLookAt(gl, 
        			eyeX, 1.0f, eyeZ, 	//ʒu(_)
        			0.0f, 0.0f, 0.0f, 	//߂ĂƂ
        			0.0f, 1.0f, 0.0f); 	//Ă
        }
        
        
		//ʃNAJ[ݒ肵āAJ[obt@(wi)AZobt@NA
		gl.glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
		gl.glClear(GL10.GL_COLOR_BUFFER_BIT | GL10.GL_DEPTH_BUFFER_BIT);
		
		//|S`
		mRenderer.draw(gl);
		
		
		//]pxXV
		mAngle += 0.1f;
		if( mAngle > 360.0f )
			mAngle = 0.0f;
		
		//ʂɏo͂obt@̐؂ւ
		EGL10 egl = (EGL10)EGLContext.getEGL();
		egl.eglSwapBuffers(mEglDisplay, mEglSurface);
	}
	
	/**
	 * OpenGL ES
	 * 
	 * 
	 * @return	IȂ^AG[ȂU
	 */
	private boolean initGLES(){
		//GL ES샂W[擾 
		EGL10 egl = (EGL10)EGLContext.getEGL();
		
		{
			//fBXvCRlNV쐬
			mEglDisplay = egl.eglGetDisplay(EGL10.EGL_DEFAULT_DISPLAY);
			if( mEglDisplay == EGL10.EGL_NO_DISPLAY ){
				Log.e(mName, "fBXvCRlNV쐬s");
				return false;
			}
			
			//fBXvCRlNV
			int[] version = new int[2];
			if( !egl.eglInitialize(mEglDisplay, version) ){
				Log.e(mName, "fBXvCRlNVs");
				return false;
			}
			
			//OpenGLo[Wo
			Log.i(mName, "OpenGL ES " +	"Version[" + version[0] + "." + version[1] + "]" );
		}
		
		{
			//RtBOݒ
			int[] configSpec = {
				/*
				 * 2008/12/1 C
				 * ȉ̐ݒ肪@ł͎gȂ悤Ȃ̂ŃJbgB
				 * ͂̕ƁAT|[gĂݒ肪g(Iɐݒ肵ȂƋ@ˑŕς\?)B
				EGL10.EGL_ALPHA_SIZE, 8,	//At@`lF8rbg
				EGL10.EGL_RED_SIZE, 8,		//ԗvfF8rbg
				EGL10.EGL_GREEN_SIZE, 8,	//ΗvfF8rbg
				EGL10.EGL_BLUE_SIZE, 8,		//vfF8rbg
				*/
				EGL10.EGL_DEPTH_SIZE, 16,	//[xobt@F16rbg
				EGL10.EGL_NONE				//I[ɂEGL_NONE
			};
			EGLConfig[] configs = new EGLConfig[1];
			int[] numConfigs = new int[1];
			if( !egl.eglChooseConfig(mEglDisplay, configSpec, configs, 1, numConfigs) ){
				Log.e(mName, "RtBOݒ莸s");
				return false;
			}
			mEglConfig = configs[0];
		}
		
		{
			//_OReLXg쐬
			mEglContext = 
				egl.eglCreateContext(mEglDisplay, mEglConfig, EGL10.EGL_NO_CONTEXT, null);
			if( mEglContext == EGL10.EGL_NO_CONTEXT ){
				Log.e(mName, "_OReLXg쐬s");
				return false;
			}
		}
		
		{
			//T[tFCX쐬(Ƃŕ̂ŕʃ\bh)
			if( !createSurface() ){
				Log.e(mName, "T[tFCX쐬s");
				return false;
			}
		}
		
		return true;
	}
	
	/**
	 * T[tFCX쐬
	 * 
	 * T[tFCX쐬āA_OReLXgƌт
	 * 
	 * @return	IȂ^AG[ȂU
	 */
	private boolean createSurface(){
		EGL10 egl = (EGL10)EGLContext.getEGL();
		
		{
			//T[tFCX쐬
			mEglSurface = 
				egl.eglCreateWindowSurface(mEglDisplay, mEglConfig, mView.getHolder(), null);
			if( mEglSurface == EGL10.EGL_NO_SURFACE ){
				Log.e(mName, "T[tFCX쐬s");
				return false;
			}
		}
		
		{
			//T[tFCXƃ_OReLXgт
			if( !egl.eglMakeCurrent(mEglDisplay, mEglSurface, mEglSurface, mEglContext) ){
				Log.e(mName, "_OReLXgƂ̌тs");
				return false;
			}
		}
		
		return true;
	}
	
	/**
	 * OpenGL ESЕt
	 */
	private void endGLES(){
		EGL10 egl = (EGL10)EGLContext.getEGL();
		
		//T[tFCXj
		if( mEglSurface != null){
			//_OReLXgƂ̌т͉
			egl.eglMakeCurrent(mEglDisplay, EGL10.EGL_NO_SURFACE, EGL10.EGL_NO_SURFACE, EGL10.EGL_NO_CONTEXT);
			
			egl.eglDestroySurface(mEglDisplay, mEglSurface);
			mEglSurface = null;
		}
		
		//_OReLXgj
		if( mEglContext != null ){
			egl.eglDestroyContext(mEglDisplay, mEglContext);
			mEglContext = null;
		}
		
		//fBXvCRlNVj
		if( mEglDisplay != null){
			egl.eglTerminate(mEglDisplay);
			mEglDisplay = null;
		}
	}
	
	/**
	 * XbhIv
	 * 
	 * XbhɏIvoāA~̂҂
	 */
	public void RequestExitAndWait(){
		synchronized (this) {
			//Ivo
			mDone = true;
		}
		
		try{
			//XbhI҂
			join();
		}
		catch( InterruptedException ex ){
			Thread.currentThread().interrupt();
		}
	}
	
	/**
	 * `⏕NX
	 */
	class Renderer{
		private FloatBuffer buffer;
		
		/**
		 * RXgN^
		 */
		public Renderer(){
			//_x_\vfx4oCg̃TCỸobt@쐬
			ByteBuffer vb = ByteBuffer.allocateDirect(4 * 3 * 4);
			vb.order(ByteOrder.nativeOrder());	//rbOGfBAgGfBAɂ킹Ă
			buffer = vb.asFloatBuffer();
		
			//_f[^Œ_obt@쐬
			float[] vertices = {
					// X,Y,Z3vfŎlp`\4_
					-0.5f, -0.5f, 0.0f,		//W(0,0,0)𒆐Sɍ
					0.5f, -0.5f, 0.0f,		//		V			E
					-0.5f, 0.5f, 0.0f,		//		V			
					0.5f, 0.5f, 0.0f,		//		V			E
			};
			buffer.put(vertices);
			buffer.position(0);
		}
		
		/**
		 * `
		 * @param gl	GLnh
		 */
		public void draw( GL10 gl ){
			//|SJ[ݒ
			gl.glColor4f(0.8f, 0.8f, 1.0f, 1.0f);
			//_obt@@\ON
			gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
			//_obt@ݒ
			gl.glVertexPointer(3, GL10.GL_FLOAT, 0, buffer);
			//`
			gl.glDrawArrays(GL10.GL_TRIANGLE_STRIP, 0, 4);
		}
	}
}
